///////////////////////////////////////////////////////////////////////
// DriverX.pas
//
// DriverX Delphi interface unit.
//
// DriverX Version 3.4
//
// Copyright (C) 1996-1998, Tetradyne Software Inc.
// All rights reserved.

unit DriverX;

interface
uses
   Windows, Winsvc, Dialogs, SysUtils, Classes;

const
   HEAP_ZERO_MEMORY = 8;

   DX_MAJOR_VER = 3;
   DX_MINOR_VER = 4;

   METHOD_BUFFERED = 0;
   METHOD_IN_DIRECT = 1;
   METHOD_OUT_DIRECT = 2;
   SERVICE_KERNEL_DRIVER = 1;
   SERVICE_AUTO_START = 2;
   SERVICE_ERROR_NORMAL = 1;

   FILE_ANY_ACCESS = 0;
   FILE_DEVICE_UNKNOWN = 34; //0x00000022

   IOCTL_EXECUTE_OPS = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2048 shl 2) or METHOD_BUFFERED;

   // Maps a device, physical, or DMA buffer memory range into the callers address space
   IOCTL_MAP_MEMORY = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2049 shl 2) or METHOD_BUFFERED;

   // Unmaps a memory range previously mapped using IOCTL_MAP_MEMORY
   IOCTL_UNMAP_MEMORY = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2050 shl 2) or METHOD_BUFFERED;

   IOCTL_WAIT_INTERRUPT = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2051 shl 2) or METHOD_BUFFERED;
   IOCTL_GET_PROPERTY = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2052 shl 2) or METHOD_BUFFERED;
   IOCTL_SET_PROPERTY = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2053 shl 2) or METHOD_BUFFERED;
   IOCTL_MAP_PORTS = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2054 shl 2) or METHOD_BUFFERED;
   IOCTL_UNMAP_PORTS = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2055 shl 2) or METHOD_BUFFERED;
   IOCTL_CONNECT_INTERRUPT = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2056 shl 2) or METHOD_BUFFERED;
   IOCTL_DISCONNECT_INTERRUPT = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2057 shl 2) or METHOD_BUFFERED;
   IOCTL_AUTOINC_READ = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2058 shl 2) or METHOD_IN_DIRECT;
   IOCTL_AUTOINC_WRITE = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2059 shl 2) or METHOD_OUT_DIRECT;
   IOCTL_BUF_AUTOINC_READ = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2060 shl 2) or METHOD_BUFFERED;
   IOCTL_BUF_AUTOINC_WRITE = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2061 shl 2) or METHOD_BUFFERED;
   IOCTL_START_DEVICE = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2064 shl 2) or METHOD_BUFFERED;
   IOCTL_STOP_DEVICE = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2065 shl 2) or METHOD_BUFFERED;
   IOCTL_GET_DEVICE_ID = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2066 shl 2) or METHOD_BUFFERED;
   IOCTL_GET_BUS_DATA_BY_OFFSET = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2067 shl 2) or METHOD_BUFFERED;
   IOCTL_SET_BUS_DATA_BY_OFFSET = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2068 shl 2) or METHOD_BUFFERED;
   IOCTL_GET_BUS_DATA_BY_OFFSET_EX = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2069 shl 2) or METHOD_BUFFERED;
   IOCTL_SET_BUS_DATA_BY_OFFSET_EX = (FILE_DEVICE_UNKNOWN shl 16) or (FILE_ANY_ACCESS shl 14)
      or ($2070 shl 2) or METHOD_BUFFERED;

   DXPROP_ISR_ENABLED       = 1;
   DXPROP_IS_INTR_CONNECTED = 2;
   DXPROP_GET_DEVICE_ID     = 3;
   DXPROP_SLOT_NUMBER       = 4;

   DXOP_INP_BASE  = $0080;
   DXOP_OUTP_BASE = $00C0;
   DXOP_INP       = $0081;
   DXOP_INPW      = $0082;
   DXOP_INPD      = $0084;
   DXOP_OUTP      = $00C1;
   DXOP_OUTPW     = $00C2;
   DXOP_OUTPD     = $00C4;

   DXOP_TEMP_OUTP_BASE = $00A0;
   DXOP_TEMP_OUTP    = $00A1;
   DXOP_TEMP_OUTPW   = $00A2;
   DXOP_TEMP_OUTPD   = $00A4;

   DXOP_BUF_INP_BASE	= $00E0;
   DXOP_BUF_INP      = $00E1;
   DXOP_BUF_INPW     = $00E2;
   DXOP_BUF_INPD     = $00E4;

   DXOP_BUF_OUTP_BASE   = $00F0;
   DXOP_BUF_OUTP        = $00F1;
   DXOP_BUF_OUTPW       = $00F2;
   DXOP_BUF_OUTPD       = $00F4;

   DXOP_DELAY           = $0001;
   DXOP_BREAK_IF_AND    = $0002;
   DXOP_WHILE_INP_AND   = $0003;
   DXOP_LOOP_BACK       = $0004;
   DXOP_BREAK_IF_EQUAL  = $0005;
   DXOP_OR_TEMP         = $0006;
   DXOP_AND_TEMP        = $0007;
   DXOP_WHILE_INP_EQU   = $0008;

   /////////////////////////////////////////////////////////////////////
   // Constants for fFlags field of MAPMEM_INPUT structure.
   //
   // DXMEM_TYPE_DEVICE returns memory range specified by MemIndex
   // registry/INF file parameter.
   //
   // DXMEM_TYPE_DEVICE2 (added in ver 3.4) returns the memory range
   // specified by the nIndex field of the MAPMEM_INPUT structure.

   DXMEM_TYPE_PHYSICAL   = 0;
   DXMEM_TYPE_DEVICE     = 1;
   DXMEM_TYPE_DMA_BUFFER = 2;
   DXMEM_TYPE_DEVICE2    = 3;

   DXOPF_TIMEOUT = $0100;

type
   EDxException = class(Exception);
   PCardinal = ^Cardinal;

   TDxPropertyInput = record
      DeviceID: Integer;
      PropCode: Integer;
      PropState: Integer;
      Reserved: Integer;
   end;

   TDxInp = record
      Offset: Integer;
      Value: Integer;
      VarAddress: ^Integer;
   end;

   TDxOutp = record
      Offset: Integer;
      Value: Integer;
   end;

   TDxDelay = record
       Delay: Integer;
   end;

   TDxBIA = record
       Mask: Integer;
       Break: Integer;
   end;

   TDxWIA = record
      Offset: Integer;
      Timeout: Integer;
      Mask: Integer;
      DataSize: Integer;
      LoopWhile: Integer;
   end;

   TDxWIE = record
      Offset: Integer;
      Timeout: Integer;
      Mask: Integer;
      DataSize: Integer;
      LoopWhile: Integer;
	  Value: Integer;
   end;

   TDxReservedOp = record
      Reserved1: Integer;
      Reserved2: Integer;
      Reserved3: Integer;
      Reserved4: Integer;
      Reserved5: Integer;
      Reserved6: Integer;
      Reserved7: Integer;
   end;

   list = (INP, OUTP, DELAY, BIA, WIA, WIE, RESERVED);

   TDxOp = record
      FlagType: Integer;
      case list of
         INP:      (Inp: TDxInp);
         OUTP:     (Outp: TDxOutp);
         DELAY:    (Delay: TDxDelay);
         BIA:      (BIA: TDxBIA);
         WIA:      (WIA: TDxWIA);
		 WIE:	   (WIE: TDxWIE);
         RESERVED: (Reserved: TDxReservedOp);
   end;

   PTDxOp = ^TDxOp;

   TDxOpHeader = record
      DeviceID: Integer;
      Version: Integer;
      Index: Integer;
      NumOps: Integer;

      NumAllocated: Integer;
      InFlags: Integer;
      OutFlags: Integer;
      BytesReturned: DWORD;

      BytesData: Integer;
      BytesDataAllocated: Integer;
      Reserved1: Integer;
      Reserved2: Integer;

      Op: TDxOp;
   end;

   PTDxOpHeader = ^TDxOpHeader;

   TWaitInterruptOutput = record
      Count: Integer;
      Data: Integer;
      IdData: Integer;
      Reserved2: Integer;
   end;

   TMapPortsInput = record
      DeviceID: Integer;
      InterfaceType: Integer;
      BusNumber: Integer;
      PortBase: Integer;
      PortCount: Integer;
      Index: Integer;
      Reserved1: Integer;
      Reserved2: Integer;
   end;

   TMapPortsOutput = record
      HalReturn: Integer;
      MappedAddress: Integer;
      AddressSpace: Integer;
      Index: Integer;
      Reserved1: Integer;
      Reserved2: Integer;
   end;

   TUnmapPortsInput = record
      DeviceID: Integer;
      Index: Integer;
      Reserved1: Integer;
      Reserved2: Integer;
   end;

   TConnectInterruptInput = record
      DeviceID: Integer;
      InterfaceType: Integer;
      BusNumber: Integer;
      InterruptLevel: Integer;
      InterruptVector: Integer;
      InterruptMode: Integer;
   end;

   TConnectInterruptOutput = record
      MappedVector: Integer;
      Irql: Integer;
      Affinity: Integer;
      Status: Integer;

      // VPICD_Virtualize_IRQ success (only field used on Win95)
      Success: Integer;
   end;

   TAutoincRwInput = record
      DeviceID: Integer;
      Index: Integer;
      Offset: Integer;
      Count: Integer;		// Size of data in bytes
      DataSize: Integer;	// Byte size (1-byte,2-word,4-long)
      Reserved1: Integer;
      Reserved2: Integer;
      Reserved3: Integer;
   end;

   BusDataParams = record
      DeviceID: Integer;
      Offset: Integer;
      BufferSize: Integer;
	  Bus: Byte;
	  Device: Byte;
	  FuncNum: Byte;
      Reserved1: Byte;
      Reserved2: Integer;
      Reserved3: Integer;
      Reserved4: Integer;
      Buffer: Integer;
   end;

   PBusDataParams = ^BusDataParams;

   TDxDevice = class;

	///////////////////////////////////////////////////////////////////////
	// TIsrThread thread class

   TIsrThread = class (TThread)
   public
      // Constructor takes parent device and ISR disable event
      constructor Create(Device: TDxDevice);
   protected
      // Thread Execute procedure calls parent device's OnInterrupt
      procedure Execute; override;
   private
      ParentDevice: TDxDevice;
   end;

   ////////////////////////////////////////////////////////////////////
   // TDxDeviceConfig device configuration class

   TDxDeviceConfig = class
   public
      DynamicDevice: Boolean;
      IgnoreConflicts: Boolean;
      VendorID: Integer;
      DeviceID: Integer;
      MemoryIo: Boolean; // PCI device w/ memory mapped registers
      DmaBufSize: Integer; // For busmaster PCI device DMA buffer
      InterfaceType: Integer; // NT DDK INTERFACE_TYPE enum
      BusNumber: Integer;

      UsesPortRange: Boolean; // set TRUE if device uses a port range
      PortBase: Integer;
      PortCount: Integer;

      UsesInterrupt: Boolean; // set TRUE if device uses an interrupt
      InterruptLevel: Integer;
      IsrOp: Integer;
      IsrData: Integer;
      IsrOffset: Integer;
      IsrIdOp: Integer;
      IsrIdOffset: Integer;
      IsrIdMask: Integer;
      IsrIdValue: Integer;
      UsesMemRange: Boolean;	// set TRUE if device uses a memory range
      MemBase: Integer;
      MemCount: Integer;

      constructor Create;
      procedure InitConfiguration;
      procedure ConfigureInterface(NewType, NewNumber: Integer);
      procedure ConfigureInterrupt(Level: Integer);
      procedure ConfigurePortRange(Base, Count: Integer);
      procedure ConfigureMemRange(Base, Count: Integer);
      procedure ConfigureIsrOp(Op, Offset, Data: Integer);
      procedure ConfigureIsrIdOp(Op, Offset, Mask, Value: Integer);

      function SetRegistryConfiguration(Key: HKEY): Integer;
      procedure ReadRegistryConfiguration(Key: HKEY);

   end;

   ///////////////////////////////////////////////////////////////////
   // TDxOpQueue operation queue.

   TDxOpQueue = class
   public
      Header: PTDxOpHeader;

      constructor Create;
      destructor Destroy; override;
      procedure AllocateOpQueue(Index, NumOps, BytesData: Integer);
      function QueueAllocated: Boolean;
      procedure Initialize(Index, Allocated, BytesData: Integer);
      function GetQueueResults(var BytesProcessed: Integer): Integer;
      function GetQueueBuffer: Pointer;

      function QueueInPort(Offset, DataSize: Integer; var RetData: Integer): Boolean;
      procedure QueueInp(Offset: Integer; var RetData: Integer);
      procedure QueueInpw(Offset: Integer; var RetData: Integer);
      procedure QueueInpl(Offset: Integer; var RetData: Integer);

      function QueueBufInPort(Offset, DataSize: Integer): Boolean;
      procedure QueueBufInp(Offset: Integer);
      procedure QueueBufInpw(Offset: Integer);
      procedure QueueBufInpl(Offset: Integer);

      function QueueOutPort(Offset, DataSize, Data: Integer): Boolean;
      procedure QueueOutp(Offset, Data: Integer);
      procedure QueueOutpw(Offset, Data: Integer);
      procedure QueueOutpl(Offset, Data: Integer);

      function QueueBufOutPort(Offset, DataSize: Integer): Boolean;
      procedure QueueBufOutp(Offset: Integer);
      procedure QueueBufOutpw(Offset: Integer);
      procedure QueueBufOutpl(Offset: Integer);

      function QueueTempOutPort(Offset, DataSize: Integer): Boolean;
      procedure QueueTempOutp(Offset: Integer);
      procedure QueueTempOutpw(Offset: Integer);
      procedure QueueTempOutpl(Offset: Integer);

      procedure QueueWhileInpAnd(Offset, DataSize, Mask: Integer;
            LoopWhile: Boolean; Limit: Integer);
      procedure QueueWhileInpEqual(Offset, DataSize, Mask, Value: Integer;
            LoopWhile: Boolean; Limit: Integer);
      procedure QueueLoopBack;
      procedure QueueBreakIfAnd(Mask: Integer; Break: Boolean);
      procedure QueueOrTemp(Mask: Integer);
      procedure QueueAndTemp(Mask: Integer);

   end;

   ////////////////////////////////////////////////////////////////////
   // TDxDevice interface to kernel-mode device services

   TDxDevice = class
   public
      WaitOutput: TWaitInterruptOutput;
      constructor Create;
      destructor Destroy; override;

      function GetID: Integer;
      function ConnectDevice(Name: string): Boolean;
      function Execute(Queue: TDxOpQueue): Boolean;
      function ExecuteHeader(Header: PTDxOpHeader): Boolean;
      procedure DeleteOps(pOpHeader: PTDxOpHeader);

      function EnableIsr(Thread: TIsrThread): Boolean;
      function DisableIsr: Boolean;
      function GetDeviceHandle: THandle;
      function GetDeviceHandleIsr: THandle;
      function GetCancelEvent: THandle;
      procedure OnInterrupt; virtual;
      procedure BeginIsrSynch;
      procedure EndIsrSynch;
      function GetIsrData: Integer;
      function GetIsrIdData: Integer;

      function MapPorts(Base, Count: Integer; var Index: Integer): Boolean;
      function UnmapPorts(Index: Integer): Boolean;
      function ConnectInterrupt(Level: Integer): Boolean;
      function DisconnectInterrupt: Boolean;
      function AutoIncReadPort(Index, Offset: Integer; Buf: Pointer;
			Count, DataSize: Integer): Boolean;
      function AutoIncWritePort(Index, Offset: Integer; Buf: Pointer;
			Count, DataSize: Integer): Boolean;

      function InPort(Index, Offset, DataSize: Integer): Integer;
      function inp(Offset: Integer): Byte;
      function inpw(Offset: Integer): Word;
      function inpl(Offset: Integer): Integer;
      function OutPort(Index, Offset, DataSize, Data: Integer): Boolean;
      function outp(Offset, Data: Integer): Boolean;
      function outpw(Offset, Data: Integer): Boolean;
      function outpl(Offset, Data: Integer): Boolean;

      function GetProperty(Code: Integer; var State: Integer): Boolean;
      function SetProperty(Code, State: Integer): Boolean;
      procedure SetErrorHandler(Enable: Boolean);

      class function IsDeviceRunning(Name: string): Boolean;
      class function StartDevice(Name: string): Boolean;
      class function StopDevice(Name: string): Boolean;
      class function ConfigureDevice(Name: string;
            Config: TDxDeviceConfig): Boolean;
      class function DeleteDeviceConfiguration(Name: string): Boolean;
      class function IsDriverConfigured: Boolean;
      class function ConfigureDriver: Boolean;
      class function EnumerateDevices(
         Index: Integer; var Name: string; Config: TDxDeviceConfig): Boolean;
      class function GetDeviceConfig(Name: string; Config: TDxDeviceConfig): Boolean;
      function GetBusDataByOffset(Offset: Integer; Buf: Pointer; BufSize: Integer): Boolean;
      function SetBusDataByOffset(Offset: Integer; Buf: Pointer; BufSize: Integer): Boolean;
      function GetBusDataByOffsetEx(Bus, Device, FuncNum: Byte; Offset: Integer; Buf: Pointer; BufSize: Integer): Boolean;
      function SetBusDataByOffsetEx(Bus, Device, FuncNum: Byte; Offset: Integer; Buf: Pointer; BufSize: Integer): Boolean;

   private
      DeviceHandle: THandle;
      DeviceHandleIsr: THandle;
      CancelEvent: THandle;
      IsrThread: TIsrThread;
      DeviceID: Cardinal;
      IsrThreadID: DWORD;
      CriticalSection: TRTLCriticalSection;
   end;

   ///////////////////////////////////////////////////////////////////////
   // Input structure for IOCTL_MAP_MEMORY IOCTL request.

   MapmemInput = record
      DeviceID: Integer;
      MemType: Integer;       // DXMEM_TYPE_xxx constant
      InterfaceType: Integer; // Only used for DXMEM_TYPE_PHYSICAL
      BusNumber: Integer;     // ""
      Address: Integer;       // ""
      Length: Integer;        // ""
      AddressSpace: Integer;  // ""
      Index: Integer;
   end;

   ///////////////////////////////////////////////////////////////////////
   // Output (return) structure for IOCTL_MAP_MEMORY IOCTL request.

   MapmemOutput = record
      PhysicalAddress: Integer; // low 32-bits
      HalAddress: Integer;
      VirtualAddress: Integer;
      DriverVirtualAddress: Integer;
      Count: Integer;
      PhysicalAddressHigh: Integer; // high 32-bits
      Reserved2: Integer;
      Reserved3: Integer;
   end;

   ///////////////////////////////////////////////////////////////////////
   // Input structure for IOCTL_UNMAP_MEMORY IOCTL request.

   UnmapmemInput = record
      DeviceID: Integer;
      MemType: Integer;
      DriverVirtualAddress: Integer;
      Index: Integer;
      Reserved2: Integer;
      Reserved3: Integer;
      Reserved4: Integer;
      Reserved5: Integer;
   end;

   ////////////////////////////////////////////////////////////////////
   // TDxMemory type used for accessing a memory range.

   TDxMemory = class
   public
      destructor Destroy; override;
      function MapMemory(BaseAddress, Count: Integer): Boolean;
      function MapMemoryEx(BaseAddress, Count, InterfaceType,
                   BusNumber: Integer): Boolean;
      function MapDeviceMemory(Device: TDxDevice): Boolean;
      function MapDmaBuffer(Device: TDxDevice): Boolean;
      function UnmapMemory: Boolean;
      function GetMemoryPointer: Pointer;
      function GetPhysicalAddress: Integer;
      function GetSize: Integer;
      function GetMemoryIndex: Integer;
      procedure SetMemoryIndex(i: Integer);

   protected
      // Return data from IOCTL_MAP_MEMORY request
      Output: MapmemOutput;

      // Associated device for mapping pre-defined device memory range
      AssocDevice: TDxDevice;

      MemType: Integer;
      Index: Integer;
   end;

implementation

var
   Platform: Integer = -1;

/////////////////// SetOsPlatform()
//
// Stores operating system platoform ID in global Platform variable.

procedure SetOsPlatform;
var
   VersionInfo: TOSVersionInfo;
begin
   VersionInfo.dwOSVersionInfoSize := sizeof(TOSVersionInfo);
   GetVersionEx(VersionInfo);
   if ((VersionInfo.dwPlatformId <> VER_PLATFORM_WIN32_NT)
      and (VersionInfo.dwPlatformId <> VER_PLATFORM_WIN32_WINDOWS)) then
      raise EDxException.Create('DriverX: Unsupported windows platform.')
   else
      Platform := VersionInfo.dwPlatformId;
end;

/////////////////// IsOnNT()

function IsOnNT: Boolean;
begin
   if Platform = -1 then
      SetOsPlatform();
   if Platform = VER_PLATFORM_WIN32_NT then
      Result := True
   else
      Result := False;
end;

/////////////////// IsOn95()

function IsOn95: Boolean;
begin
   if Platform = -1 then
      SetOsPlatform();
   if Platform = VER_PLATFORM_WIN32_WINDOWS then
      Result := True
   else
      Result := False;
end;

			/////////////////////////////////////
			// TDxOpQueue implementation
			////////////////////////////////////

/////////////////// TDxOpQueue.Create()

constructor TDxOpQueue.Create;
begin
   inherited Create;
   Header := nil;
end;

/////////////////// TDxOpQueue.Destroy()

destructor TDxOpQueue.Destroy;
begin
   if (Header <> nil) then
      HeapFree(GetProcessHeap(), 0, Header);
   inherited Destroy;
end;

/////////////////// Initialize()
//
// Helper routine which initializes an operation queue header.

procedure TDxOpQueue.Initialize(Index, Allocated, BytesData: Integer);
begin
   Header.Version := (DX_MAJOR_VER shl 16) or DX_MINOR_VER;
   Header.Index := Index;
   Header.NumAllocated := Allocated;
   Header.BytesData := BytesData;
   Header.BytesDataAllocated := BytesData;
end;

/////////////////// GetQueueResults

function TDxOpQueue.GetQueueResults(var BytesProcessed: Integer): Integer;
begin
   BytesProcessed := Header.BytesReturned;
   Result := Header.OutFlags;
end;

/////////////////// GetQueueBuffer

function TDxOpQueue.GetQueueBuffer: Pointer;
var
   Op: PTDxOp;
begin
   Op := @Header.Op;
   Inc(Op, Header.NumAllocated);
   Result := Pointer(Op);
end;

/////////////////// QueueAllocated()
//
// Returns TRUE if memory for operation queue has been allocated.

function TDxOpQueue.QueueAllocated: Boolean;
begin
   if (Header <> nil) then
      Result := True
   else
      Result := False;
end;

/////////////////// AllocateOpQueue()
//
// Creates and initializes an operation queue.
//
// Parameters:
//
//		Port (IN) - port range for queued operations.
//		NumOps (IN) - number of operations in this block.
//		BytesData (IN) - size of data buffer for queue.

procedure TDxOpQueue.AllocateOpQueue(Index, NumOps, BytesData: Integer);
begin

   if (Header <> nil) then
   begin
       HeapFree(GetProcessHeap(), 0, Header);
       Header := nil;
   end;

   if (NumOps > 0) then
   begin
       Header := PTDxOpHeader(HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY,
           sizeof(TDxOpHeader) + (NumOps-1) * sizeof(TDxOp) + BytesData));
       if (Header <> nil) then
           Initialize(Index, NumOps, BytesData);
   end;
end;

/////////////////// TDxOpQueue.QueueInPort()
//
// Queues a single port read operation in an array of TDxOp structures.

function TDxOpQueue.QueueInPort(Offset, DataSize: Integer; var RetData: Integer): Boolean;
var
  Op: PTDxOp;

begin
   // Check if there is room in OpHeader
   if (Header.NumOps < Header.NumAllocated) then
   begin
       // Get a pointer to the correct DxOp record
       Op := @Header.Op;
       Inc(Op, Header.NumOps);

       Op.FlagType := DXOP_INP_BASE + DataSize;
       Op.Inp.Offset := Offset;
       Op.Inp.VarAddress := @RetData;
       Inc(Header.NumOps);
       Result := True;
   end
   else
       Result := False
end;

procedure TDxOpQueue.QueueInp(Offset: Integer; var RetData: Integer);
begin
   QueueInPort(Offset, 1, RetData);
end;

procedure TDxOpQueue.QueueInpw(Offset: Integer; var RetData: Integer);
begin
   QueueInPort(Offset, 2, RetData);
end;

procedure TDxOpQueue.QueueInpl(Offset: Integer; var RetData: Integer);
begin
   QueueInPort(Offset, 4, RetData);
end;

/////////////////// QueueBufInPort()

function TDxOpQueue.QueueBufInPort(Offset, DataSize: Integer): Boolean;
var
   Op: PTDxOp;

begin
   // Check if there is room in OpHeader
   if (Header.NumOps < Header.NumAllocated) then
   begin
      // Get a pointer to the correct DxOp record
      Op := @Header.Op;
      Inc(Op, Header.NumOps);

      Op.FlagType := DXOP_BUF_INP_BASE + DataSize;
      Op.Inp.Offset := Offset;
      Inc(Header.NumOps);
      Result := True;
   end
   else
      Result := False
end;

procedure TDxOpQueue.QueueBufInp(Offset: Integer);
begin
   QueueBufInPort(Offset, 1);
end;

procedure TDxOpQueue.QueueBufInpw(Offset: Integer);
begin
   QueueBufInPort(Offset, 2);
end;

procedure TDxOpQueue.QueueBufInpl(Offset: Integer);
begin
   QueueBufInPort(Offset, 4);
end;

/////////////////// QueueOutPort()
//
// Queues a port write operation in an array of TDxOp structures.

function TDxOpQueue.QueueOutPort(Offset, DataSize, Data: Integer): Boolean;
var
   Op: PTDxOp;

begin
   // Check if there is room in OpHeader
   if (Header.NumOps < Header.NumAllocated) then
   begin
       // Get a pointer to the correct DxOp record
       Op := @Header.Op;
       Inc(Op, Header.NumOps);

       Op.FlagType := DXOP_OUTP_BASE + DataSize;
       Op.Outp.Offset := Offset;
       Op.Outp.Value := Data;
       Inc(Header.NumOps);
       Result := True;
   end
   else
       Result := False;
end;

procedure TDxOpQueue.QueueOutp(Offset, Data: Integer);
begin
   QueueOutPort(Offset, 1, Data);
end;

procedure TDxOpQueue.QueueOutpw(Offset, Data: Integer);
begin
   QueueOutPort(Offset, 2, Data);
end;

procedure TDxOpQueue.QueueOutpl(Offset, Data: Integer);
begin
   QueueOutPort(Offset, 4, Data);
end;

/////////////////// QueueTempOutPort()

function TDxOpQueue.QueueTempOutPort(Offset, DataSize: Integer): Boolean;
var
   Op: PTDxOp;

begin
   // Check if there is room in OpHeader
   if (Header.NumOps < Header.NumAllocated) then
   begin
      // Get a pointer to the correct DxOp record
      Op := @Header.Op;
      Inc(Op, Header.NumOps);

      Op.FlagType := DXOP_TEMP_OUTP_BASE + DataSize;
      Op.Outp.Offset := Offset;
      Inc(Header.NumOps);
      Result := True;
   end
   else
      Result := False
end;

procedure TDxOpQueue.QueueTempOutp(Offset: Integer);
begin
   QueueTempOutPort(Offset, 1);
end;

procedure TDxOpQueue.QueueTempOutpw(Offset: Integer);
begin
   QueueTempOutPort(Offset, 2);
end;

procedure TDxOpQueue.QueueTempOutpl(Offset: Integer);
begin
   QueueTempOutPort(Offset, 4);
end;

/////////////////// QueueBufOutPort()

function TDxOpQueue.QueueBufOutPort(Offset, DataSize: Integer): Boolean;
var
   Op: PTDxOp;

begin
   // Check if there is room in OpHeader
   if (Header.NumOps < Header.NumAllocated) then
   begin
      // Get a pointer to the correct DxOp record
      Op := @Header.Op;
      Inc(Op, Header.NumOps);

      Op.FlagType := DXOP_BUF_OUTP_BASE + DataSize;
      Op.Outp.Offset := Offset;
      Inc(Header.NumOps);
      Result := True;
   end
   else
      Result := False
end;

procedure TDxOpQueue.QueueBufOutp(Offset: Integer);
begin
   QueueBufOutPort(Offset, 1);
end;

procedure TDxOpQueue.QueueBufOutpw(Offset: Integer);
begin
   QueueBufOutPort(Offset, 2);
end;

procedure TDxOpQueue.QueueBufOutpl(Offset: Integer);
begin
   QueueBufOutPort(Offset, 4);
end;

procedure TDxOpQueue.QueueWhileInpAnd(Offset, DataSize, Mask: Integer;
    LoopWhile: Boolean; Limit: Integer);
var
   Op: PTDxOp;
begin
   // Check if there is room in OpHeader
   if (Header.NumOps < Header.NumAllocated) then
   begin
      // Get a pointer to the correct DxOp record
      Op := @Header.Op;
      Inc(Op, Header.NumOps);

      Op.FlagType    := DXOP_WHILE_INP_AND;
      Op.WIA.Offset  := Offset;
      Op.WIA.Timeout := Limit;
      Op.WIA.Mask    := Mask;
      Op.WIA.DataSize := DataSize;
      Op.WIA.LoopWhile := Integer(LoopWhile);
      Inc(Header.NumOps);
   end;
end;

procedure TDxOpQueue.QueueWhileInpEqual(Offset, DataSize, Mask, Value: Integer;
    LoopWhile: Boolean; Limit: Integer);
var
   Op: PTDxOp;
begin
   // Check if there is room in OpHeader
   if (Header.NumOps < Header.NumAllocated) then
   begin
      // Get a pointer to the correct DxOp record
      Op := @Header.Op;
      Inc(Op, Header.NumOps);

      Op.FlagType    := DXOP_WHILE_INP_EQU;
      Op.WIE.Offset  := Offset;
      Op.WIE.Timeout := Limit;
      Op.WIE.Mask    := Mask;
      Op.WIE.Value   := Value;
      Op.WIE.DataSize := DataSize;
      Op.WIE.LoopWhile := Integer(LoopWhile);
      Inc(Header.NumOps);
   end;
end;

procedure TDxOpQueue.QueueLoopBack;
var
   Op: PTDxOp;
begin
   // Check if there is room in OpHeader
   if (Header.NumOps < Header.NumAllocated) then
   begin
      // Get a pointer to the correct DxOp record
      Op := @Header.Op;
      Inc(Op, Header.NumOps);

      Op.FlagType := DXOP_LOOP_BACK;
      Inc(Header.NumOps);
   end;
end;

procedure TDxOpQueue.QueueBreakIfAnd(Mask: Integer; Break: Boolean);
var
   Op: PTDxOp;
begin
   // Check if there is room in OpHeader
   if (Header.NumOps < Header.NumAllocated) then
   begin
      // Get a pointer to the correct DxOp record
      Op := @Header.Op;
      Inc(Op, Header.NumOps);

      Op.FlagType := DXOP_BREAK_IF_AND;
      Op.BIA.Mask := Mask;
      Op.BIA.Break := Integer(Break);
      Inc(Header.NumOps);
   end;
end;

procedure TDxOpQueue.QueueOrTemp(Mask: Integer);
var
   Op: PTDxOp;
begin
   // Check if there is room in OpHeader
   if (Header.NumOps < Header.NumAllocated) then
   begin
      // Get a pointer to the correct DxOp record
      Op := @Header.Op;
      Inc(Op, Header.NumOps);

      Op.FlagType := DXOP_OR_TEMP;
      Op.Reserved.Reserved1 := Mask;
      Inc(Header.NumOps);
   end;
end;

procedure TDxOpQueue.QueueAndTemp(Mask: Integer);
var
   Op: PTDxOp;
begin
   // Check if there is room in OpHeader
   if (Header.NumOps < Header.NumAllocated) then
   begin
      // Get a pointer to the correct DxOp record
      Op := @Header.Op;
      Inc(Op, Header.NumOps);

      Op.FlagType := DXOP_AND_TEMP;
      Op.Reserved.Reserved1 := Mask;
      Inc(Header.NumOps);
   end;
end;

			/////////////////////////////////////
			// TDxDevice implementation
			////////////////////////////////////

/////////////////// Create()

constructor TDxDevice.Create;
begin
   inherited Create;
   DeviceHandle := INVALID_HANDLE_VALUE;
   DeviceHandleIsr := INVALID_HANDLE_VALUE;
   CancelEvent := CreateEvent(nil, True, False, nil);
   InitializeCriticalSection(CriticalSection);
end;

/////////////////// Destroy()

destructor TDxDevice.Destroy;
begin
   DisableIsr;

   // The clean up routine will clean the wait for interrupt IRP
   if DeviceHandle <> INVALID_HANDLE_VALUE then
      CloseHandle(DeviceHandle);

   if DeviceHandleIsr <> INVALID_HANDLE_VALUE then
      CloseHandle(DeviceHandleIsr);

   if CancelEvent <> 0 then
      CloseHandle(CancelEvent);

   DeleteCriticalSection(CriticalSection);
   inherited Destroy;
end;

procedure TDxDevice.OnInterrupt;
begin
end;

/////////////////// GetID()

function TDxDevice.GetID: Integer;
begin
   Result := DeviceID;
end;

/////////////////// ConnectDevice()
//
// Associates this TDxDevice object with a kernel-mode device object.
//
// Returns True if successful.

function TDxDevice.ConnectDevice(Name: string): Boolean;
var
   DevID: Integer;
   BytesReturned: DWORD;
   Ret : Boolean;
begin

   if Length(Name) = 0 then
       Name := '_Default30';

   if IsOn95 then
   begin

      // Open handle to DriverX VxD
      DeviceHandle := CreateFile('\\.\DRIVERX.VXD',
            0,
            0,
            nil,
            0,
            0,
            0);

      if (DeviceHandle = INVALID_HANDLE_VALUE) then
      begin
         Result := FALSE;
         Exit;
      end;

      Ret := DeviceIoControl(DeviceHandle,
                   IOCTL_GET_DEVICE_ID,
                   PChar(Name),
                   Length(Name),
                   @DevID,
                   Sizeof(Integer),
                   BytesReturned,
                   nil);

      if ((Ret = False) or (DevID = -1)) then
      begin
         CloseHandle(DeviceHandle);
         DeviceHandle := INVALID_HANDLE_VALUE;
         Result := False;
         Exit;
      end;

      // Open second handle for ISR thread (OVERLAPPED I/O)
      DeviceHandleIsr := CreateFile('\\.\DRIVERX.VXD',
            0,
            0,
            nil,
            0,
            FILE_FLAG_OVERLAPPED,
            0);

      if (DeviceHandleIsr = INVALID_HANDLE_VALUE) then
      begin
         CloseHandle(DeviceHandle);
         DeviceHandle := INVALID_HANDLE_VALUE;
         Result := False;
         Exit;
      end;

      // Success
      DeviceID := DevID;
      Result := True;

   end
   else
   begin

      // On NT, open handle to device object
      DeviceID := 0;
      Name := '\\.\' + Name;
      DeviceHandle := CreateFile(PChar(Name),
            GENERIC_READ or GENERIC_WRITE,
            0,
            nil,
            OPEN_EXISTING,
            FILE_ATTRIBUTE_NORMAL,
            0);

      if (DeviceHandle = INVALID_HANDLE_VALUE) then
         Result := FALSE
      else
      begin

         // Open second handle for ISR thread (overlapped I/O)
         DeviceHandleIsr := CreateFile(PChar(Name), 
            GENERIC_READ or GENERIC_WRITE, 
            0,
            nil,
            OPEN_EXISTING,
            FILE_ATTRIBUTE_NORMAL or FILE_FLAG_OVERLAPPED,
            0);

         if (DeviceHandleIsr = INVALID_HANDLE_VALUE) then
         begin
            CloseHandle(DeviceHandle);
            DeviceHandle := INVALID_HANDLE_VALUE;
            Result := False;
         end
         else                  
            Result := True;
      end;
	end;
end;

function TDxDevice.GetDeviceHandle: THandle;
begin
   Result := DeviceHandle;
end;

function TDxDevice.GetDeviceHandleIsr: THandle;
begin
   Result := DeviceHandleIsr;
end;

function TDxDevice.GetCancelEvent: THandle;
begin
   Result := CancelEvent;
end;

procedure TDxDevice.BeginIsrSynch;
begin
   EnterCriticalSection(CriticalSection);
end;

procedure TDxDevice.EndIsrSynch;
begin
   LeaveCriticalSection(CriticalSection);
end;

function TDxDevice.GetIsrData: Integer;
begin
   Result := WaitOutput.Data;
end;

function TDxDevice.GetIsrIdData: Integer;
begin
   Result := WaitOutput.IdData;
end;

/////////////////// TDxDevice.SetErrorHandler()

procedure TDxDevice.SetErrorHandler(Enable: Boolean);
begin
   // Error exceptions always enabled in 3.00
end;

/////////////////// InitializeOpHeader()
//
// Helper routine which initializes an operation queue header.

procedure InitializeOpHeader(var Header: TDxOpHeader; Index, NumAllocated, BytesData: Integer);
begin
   Header.Version := (DX_MAJOR_VER shl 16) or DX_MINOR_VER;
   Header.Index := Index;
   Header.NumAllocated := NumAllocated;
   Header.BytesData := BytesData;
   Header.BytesDataAllocated := BytesData;
end;

/////////////////// TDxDevice.Execute()

function TDxDevice.Execute(Queue: TDxOpQueue): Boolean;
begin
   Result := ExecuteHeader(Queue.Header);
end;

/////////////////// TDxDevice.ExecuteHeader()
//
// Executes a list of one or more operations.
//
// Parameters:
//
//		Header (IN) - array of operations to execute in driver
//
// Return Value:
//
//		Returns True if successful, False on error.

function TDxDevice.ExecuteHeader(Header: PTDxOpHeader): Boolean;
var
   Return: Boolean;
   BytesReturned: DWORD;
   BufferSize: Cardinal;
   p: PTDxOp;
   i: Cardinal;

begin

   // Return success if queue is empty
   if (Header.NumOps = 0) then
   begin
       Result := True;
       Exit;
   end;

   BufferSize := sizeof(TDxOpHeader) +
       (Header.NumAllocated - 1) * Sizeof(TDxOp) +
       Header.BytesData;

   // For 3.00 synch at user-mode level
   Header.InFlags := 1;
   Header.DeviceID := DeviceID;
   EnterCriticalSection(CriticalSection);

   Return := DeviceIoControl(GetDeviceHandle,
            IOCTL_EXECUTE_OPS,
            Header, BufferSize,
            Header, BufferSize,
            BytesReturned,
            nil);

   if (Return = False) then
   begin
       LeaveCriticalSection(CriticalSection);
       raise EDxException.Create('Executing port I/O failed.');
   end;

   LeaveCriticalSection(CriticalSection);

   // Store the data for any inp operations
   p := @Header.Op;
   for i := 0 to (Header.NumOps -1) do
   begin
       case p.FlagType of
           DXOP_INP..DXOP_INPD:
               if (p.Inp.VarAddress <> nil) then
                   p.Inp.VarAddress^ := p.Inp.Value;
       end;
       Inc(p);
   end;

   // Reset the queue
   Header.NumOps := 0;
   Result := True;
end;

/////////////////// DeleteOps()
//
// Queues a single port read operation in an array of TDxOp structures.

procedure TDxDevice.DeleteOps(pOpHeader: PTDxOpHeader);
begin
   if (pOpHeader <> nil) then
      HeapFree(GetProcessHeap(), 0, pOpHeader);
end;

/////////////////// EnableIsr()
//
// Creates ISR thread which blocks on interrupts in the driver and
// calls parent device's OnInterrupt routine.

function TDxDevice.EnableIsr(Thread: TIsrThread): Boolean;
var
   Ret: Boolean;
   IntConnected: Integer;

begin
   // Return error if ISR already enabled
   if (IsrThread <> nil) then
   begin
       Result := False;
       Exit;
   end;

   // Check that interrupt is connected
   Ret := GetProperty(DXPROP_IS_INTR_CONNECTED, IntConnected);
   if (Ret) then
   begin
      if (IntConnected = 0) then
         Ret := False
   end;

   if (Ret = False) then
   begin
       Result := False;
       Exit;
   end;

   // Create thread to run interrupt callbacks (if thread param is not passed)
   if (Thread = nil) then
       IsrThread := TIsrThread.Create(self)
   else
       IsrThread := Thread;

   // Store thread ID before letting thread run
   IsrThreadID := IsrThread.ThreadID;
   SetProperty(DXPROP_ISR_ENABLED, 1);
   ResetEvent(CancelEvent);
   IsrThread.Resume;
   Result := True;
end;

/////////////////// DisableIsr()
//
// Kills the ISR thread.

function TDxDevice.DisableIsr(): Boolean;
begin
   if IsrThread <> nil then
   begin
      IsrThread.Terminate;
      SetEvent(CancelEvent);
      WaitForSingleObject(IsrThread.Handle, 4000);
      IsrThread.Free;
      IsrThread := nil;
   end;
   Result := True;
end;

/////////////////// TDxDevice.MapPorts()
//
// Sets a port range for access.

function TDxDevice.MapPorts(Base, Count: Integer; var Index: Integer): Boolean;
var
   Input: TMapPortsInput;
   Output: TMapPortsOutput;
   BytesReturned: DWORD;
begin

   // Check that device is connected to kernel-mode device
   if (DeviceHandle = INVALID_HANDLE_VALUE) then
   begin
      Result := False;
      Exit;
   end;

   Input.DeviceID  := DeviceID;
   Input.InterfaceType := 1; // Isa
   Input.BusNumber := 0;
   Input.PortBase  := Base;
   Input.PortCount := Count;
   Input.Index     := Index;
   Input.Reserved1 := 0;
   Input.Reserved2 := 0;

   Result := DeviceIoControl(DeviceHandle,
            IOCTL_MAP_PORTS,
            @Input, Sizeof(TMapPortsInput),
            @Output, Sizeof(TMapPortsOutput),
            BytesReturned,
            nil);

   if (Output.HalReturn = 0) then
      Result := False;

   if (Result = True) then
      Index := Output.Index;

end;

/////////////////// TDxDevice.UnmapPorts()
//
// Frees a port range mapping on the driver side.

function TDxDevice.UnmapPorts(Index: Integer): Boolean;
var
    Input: TUnmapPortsInput;
    BytesReturned: DWORD;
begin

    // Check that device is connected to kernel-mode device
    if (DeviceHandle = INVALID_HANDLE_VALUE) then
    begin
        Result := False;
        Exit;
    end;

    Input.DeviceID := DeviceID;
    Input.Index := Index;
    Input.Reserved1 := 0;
    Input.Reserved2 := 0;

    Result := DeviceIoControl(DeviceHandle,
                IOCTL_UNMAP_PORTS,
                @Input, Sizeof(TUnmapPortsInput),
                nil, 0,
                BytesReturned,
                nil);

end;

//////////////////// TDxDevice.ConnectInterrupt

function TDxDevice.ConnectInterrupt(Level: Integer): Boolean;
var
   Input: TConnectInterruptInput;
   Output: TConnectInterruptOutput;
   BytesReturned: DWORD;

begin
	Input.DeviceID := DeviceID;
	Input.InterfaceType := 1; // Isa
	Input.BusNumber := 0;
	Input.InterruptLevel := Level;
	Input.InterruptVector := Level;
	Input.InterruptMode := 1; // latched

   Output.MappedVector := 0;
   Output.Irql := 0;
   Output.Affinity := 0;
   Output.Status := 0;
   Output.Success := 0;

   Result := DeviceIoControl(DeviceHandle,
                   IOCTL_CONNECT_INTERRUPT,
					@Input,
					Sizeof(TConnectInterruptInput),
					@Output,
					Sizeof(TConnectInterruptOutput),
					BytesReturned,
					nil);
end;

/////////////////// HwDisconnectInterrupt()
//
// Unhooks the kernel device associated with a given HWDEVICE from
// any interrupt it may be connected with.

function TDxDevice.DisconnectInterrupt: Boolean;
var
   BytesReturned: DWORD;
   ID: Integer;
begin
	ID := DeviceID;
	Result := DeviceIoControl(DeviceHandle,
                   IOCTL_DISCONNECT_INTERRUPT,
					@ID,
					Sizeof(Integer),
					nil,
					0,
					BytesReturned,
					nil);
end;



/////////////////// TDxDevice.InPort()
//
// Executes a single port read operation.
//
// Parameters:
//
//		Offset (IN) - offset into port range.
//		DataSize (IN) - data size (1-byte, 2-word, 4-long).
//
// Return Value:
//
//		Port value.

function TDxDevice.InPort(Index, Offset, DataSize: Integer): Integer;
var
   Header: TDxOpHeader;
begin
   InitializeOpHeader(Header, Index, 1, 0);
   Header.Op.FlagType := DXOP_INP_BASE + DataSize;
   Header.Op.Inp.Offset := Offset;
   Header.Op.Inp.VarAddress := nil;
   Header.NumOps := 1;
   ExecuteHeader(@Header);
   Result := Header.Op.Inp.Value;
end;

/////////////////// TDxDevice.inp()

function TDxDevice.inp(Offset: Integer): Byte;
begin
	Result := Byte(InPort(0, Offset, Sizeof(Byte)));
end;

/////////////////// TDxDevice.inpw()

function TDxDevice.inpw(Offset: Integer): Word;
begin
	Result := Word(InPort(0, Offset, Sizeof(Word)));
end;

/////////////////// TDxDevice.inpl()

function TDxDevice.inpl(Offset: Integer): Integer;
begin
	Result := InPort(0, Offset, Sizeof(Integer));
end;

/////////////////// TDxDevice.OutPort()
//
// Executes a single port write operation.
//
// Parameters:
//
//		Offset (IN) - offset into port range.
//		DataSize (IN) - data size (1-byte, 2-word, 4-long).
//		Data (IN) - data to write.

function TDxDevice.OutPort(Index, Offset, DataSize, Data: Integer): Boolean;
var
   Header: TDxOpHeader;
begin
   InitializeOpHeader(Header, Index, 1, 0);
   Header.Op.FlagType := DXOP_OUTP_BASE + DataSize;
   Header.Op.Outp.Offset := Offset;
   Header.Op.Outp.Value := Data;
   Header.NumOps := 1;
   Result := ExecuteHeader(@Header);
end;

/////////////////// TDxDevice.outp()

function TDxDevice.outp(Offset, Data: Integer): Boolean;
begin
   Result := OutPort(0, Offset, Sizeof(Byte), Data);
end;

/////////////////// TDxDevice.outpw()

function TDxDevice.outpw(Offset, Data: Integer): Boolean;
begin
   Result := OutPort(0, Offset, Sizeof(Word), Data);
end;

/////////////////// TDxDevice.outpl()

function TDxDevice.outpl(Offset, Data: Integer): Boolean;
begin
   Result := OutPort(0, Offset, Sizeof(Integer), Data);
end;

// TDxDevice.HwAutoIncReadPort()

function TDxDevice.AutoIncReadPort(Index, Offset: Integer; Buf: Pointer;
       Count, DataSize: Integer): Boolean;
var
   Input: TAutoincRwInput;
   BytesReturned: DWORD;

begin

   Input.DeviceID   := DeviceID;
   Input.Index	    := Index;
   Input.Offset     := Offset;
   Input.Count	    := Count;
   Input.DataSize   := DataSize;
   Input.Reserved1  := 0;
   Input.Reserved2  := 0;
   Input.Reserved3  := 0;

   Result := DeviceIoControl(DeviceHandle,
               IOCTL_AUTOINC_READ,
               @Input,
               Sizeof(TAutoincRwInput),
               Buf,
               Count,
               BytesReturned,
               nil);
end;

/////////////////// TDxDevice.AutoIncWritePort()

function TDxDevice.AutoIncWritePort(Index, Offset: Integer; Buf: Pointer;
   Count, DataSize: Integer): Boolean;
var
   Input: TAutoincRwInput;
   BytesReturned: DWORD;

begin
   Input.DeviceID   := DeviceID;
   Input.Index	    := Index;
   Input.Offset	    := Offset;
   Input.Count	    := Count;
   Input.DataSize   := DataSize;
   Input.Reserved1  := 0;
   Input.Reserved2  := 0;
   Input.Reserved3  := 0;

   Result := DeviceIoControl(DeviceHandle,
               IOCTL_AUTOINC_WRITE,
               @Input,
               Sizeof(TAutoincRwInput),
               Buf,
               Count,
               BytesReturned,
               nil);
end;

/////////////////// GetProperty()
//
// Retrieves a device property.
//
// Parameters:
//
//     Code (IN) -code for property to get.
//     State (OUT) -value of property returned in this variable.
//
// Return Value:
//
//     True if device supports specified property; else False.

function TDxDevice.GetProperty(Code: Integer; var State: Integer): Boolean;
var
  BytesReturned: DWORD;
  PropInput: TDxPropertyInput;

begin
   PropInput.DeviceID := DeviceId;
   PropInput.PropCode := Code;
   PropInput.PropState := 0;
   PropInput.Reserved := 0;

   Result := DeviceIoControl(GetDeviceHandle,
           IOCTL_GET_PROPERTY,
           @PropInput, sizeof(TDxPropertyInput),
           @State, sizeof(Integer),
           BytesReturned,
           nil);
end;

/////////////////// SetProperty()
//
// Sets a device property.
//
// Parameters:
//
//     Code (IN) -code for property to set.
//     State (IN) -new state for property.
//
// Return Value:
//
//        Returns True if devices supports specified property; else False.

function TDxDevice.SetProperty(Code, State: Integer): Boolean;
var
  BytesReturned: DWORD;
  PropInput: TDxPropertyInput;

begin
  PropInput.DeviceID := DeviceId;
  PropInput.PropCode := Code;
  PropInput.PropState := State;

  Result := DeviceIoControl(GetDeviceHandle,
               IOCTL_SET_PROPERTY,
               @PropInput, Sizeof(TDxPropertyInput),
               nil, 0,
               BytesReturned,
               nil);

end;

/////////////////// TDxDevice.IsDeviceRunning()
//
// Returns True if a device object is currently running and ready
// for use.

class function TDxDevice.IsDeviceRunning(Name: string): Boolean;
var
   Device: TDxDevice;
begin
   Device := TDxDevice.Create;
   Result := Device.ConnectDevice(Name);
   Device.Free;
end;

/////////////////// TDxDevice.StartDevice()
//
// Creates a kernel-mode device object.

class function TDxDevice.StartDevice(Name: string): Boolean;
var
   Device: THandle;
   BytesReturned: DWORD;
begin

   if IsDeviceRunning(Name) then
   begin
      Result := True;
      Exit;
   end;

   if IsOn95 then
      Device := CreateFile('\\.\DRIVERX.VXD',
			0,
			0,
			nil,
			0,
			FILE_FLAG_DELETE_ON_CLOSE
				or FILE_FLAG_OVERLAPPED,
			0)
   else
       Device := CreateFile('\\.\_Default30',
              GENERIC_READ or GENERIC_WRITE,
              0,
              nil,
              OPEN_EXISTING,
              FILE_ATTRIBUTE_NORMAL
                 or FILE_FLAG_OVERLAPPED,
              0);

   if Device = INVALID_HANDLE_VALUE then
   begin
      Result := False;
      Exit;
   end;

   // Send command to start device

   Result := DeviceIoControl(Device,
       IOCTL_START_DEVICE,
       PChar(Name),
       Length(Name)+1,
       nil,
       0,
       BytesReturned,
       nil);

   CloseHandle(Device);
end;

/////////////////// TDxDevice.StopDevice()
//
// Destroys a kernel-mode device object.

class function TDxDevice.StopDevice(Name: string): Boolean;
var
   Device: THandle;
   BytesReturned: DWORD;
begin

   // Open handle to VxD or _Default device
   if (IsOn95) then
      Device := CreateFile('\\.\DRIVERX.VXD',
			0,
			0,
			nil,
			0,
			FILE_FLAG_DELETE_ON_CLOSE
				or FILE_FLAG_OVERLAPPED,
			0)
   else
      Device := CreateFile('\\.\_Default30',
         GENERIC_READ or GENERIC_WRITE,
         0,
         nil,
         OPEN_EXISTING,
         FILE_ATTRIBUTE_NORMAL or
            FILE_FLAG_OVERLAPPED,
         0);

   if (Device = INVALID_HANDLE_VALUE) then
   begin
      Result := False;
      Exit;
   end;

   // Send command to stop device
   if (IsOnNT) then
      Name := '\Device\' + Name;

   Result := DeviceIoControl(Device,
          IOCTL_STOP_DEVICE,
          PChar(Name),
          Length(Name)+1,
          nil,
          0,
          BytesReturned,
          nil);

   CloseHandle(Device);
end;

/////////////////// OpenKey()
//
// Helper function to open a registry key and optionally create it if
// not found.
//
// Returns ERROR_SUCCESS if successful, else an Win32 error code.

function OpenKey(ParentKey: HKEY; SubkeyName: string; var SubKey:
	HKEY; CreateKey: Boolean): Integer;
var
	Ret: Cardinal;
	Disposition: Integer;

begin
	Ret := RegOpenKeyEx(ParentKey,
					PChar(SubkeyName),
					0,
					KEY_ALL_ACCESS,
					Subkey);

	if ((Ret <> ERROR_SUCCESS)  And (CreateKey = True)) then
		Ret := RegCreateKeyEx(ParentKey,
					PChar(SubkeyName),
					0,
					nil,
					0,
					KEY_ALL_ACCESS,
					nil,
					Subkey,
					@Disposition);

	Result := Ret;
end;

/////////////////// OpenDriverKey()
//
// Opens the DriverX driver registry key.
//
// Returns ERROR_SUCCESS if successful, else a Win32 error code.

function OpenDriverKey(var KeyDriver: HKEY): Integer;
var
	Ret: Integer;
   Path: string;
begin

	if (IsOn95) then
	begin
   	Path := 'System\CurrentControlSet\Services\VxD\DRIVERX';
		Ret := RegOpenKeyEx(HKEY_LOCAL_MACHINE,
			PChar(Path),
			0,
			KEY_ALL_ACCESS,
			KeyDriver);
	end
	else
	begin
   	Path := 'System\CurrentControlSet\Services\DriverX';
		Ret := RegOpenKeyEx(HKEY_LOCAL_MACHINE,
			PChar(Path),
			0,
			KEY_ALL_ACCESS,
       	KeyDriver);
	end;
	Result := Ret;
end;

/////////////////// OpenUserDevicesKey()

function OpenUserDevicesKey(var KeyUserDevices: HKEY): Integer;
var
	KeyDriver: HKEY;
   Ret: Integer;
begin

	// Open driver key
	Ret := OpenDriverKey(KeyDriver);
	if (Ret = ERROR_SUCCESS) then
	begin
		if (IsOn95) then
			// On Windows 95, user devices are under DRIVERX key
       	KeyUserDevices := KeyDriver
		else
		begin
			// On NT, user devices are under a Parameters subkey
			Ret := OpenKey(KeyDriver, 'Parameters', KeyUserDevices, True);
			RegCloseKey(KeyDriver);
		end;
	end;
	Result := Ret;
end;

/////////////////// TDxDevice.ConfigureDevice()
//
// Sets a device's configuration registry value entries.
//
// On NT, user device keys are held under
//
//		HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services
//			\Drivers\DriverX\Parameters
//
// On Windows 95 user device keys are under
//
//
//		HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services
//			\VxD\DRIVERX
//
// Return Value:
//
//		Returns TRUE if successful; FALSE if no key with the given name
//		is found under the DriverX key.

class function TDxDevice.ConfigureDevice(
	Name: string;
   Config: TDxDeviceConfig): Boolean;
var
   KeyUserDevices, KeyDevice: HKEY;
   Ret: Cardinal;

begin
   // Open the key under which user device configurations are stored
   KeyUserDevices := 0;
   if (OpenUserDevicesKey(KeyUserDevices) <> ERROR_SUCCESS) then
   begin
      Result := False;
      Exit;
   end;

   // Create or open the subkey with the given device name
   Ret := OpenKey(KeyUserDevices, Name, KeyDevice, True);
   RegCloseKey(KeyUserDevices);
   if (Ret <> ERROR_SUCCESS) then
   begin
      Result := False;
      Exit;
   end;

   // Set the configuration values under the device key
   Config.SetRegistryConfiguration(KeyDevice);

   RegFlushKey(KeyDevice);
   RegCloseKey(KeyDevice);

   Result := True;
end;

/////////////////// TDxDevice.IsDriverConfigured()
//
// Returns True if the DriverX registry key exists.

class function TDxDevice.IsDriverConfigured: Boolean;
var
	KeyDriver: HKEY;
begin

	if (OpenDriverKey(KeyDriver) = ERROR_SUCCESS) then
	begin
		RegCloseKey(KeyDriver);
		Result := True;
	end
	else
		Result := False;
end;

/////////////////// TDxDevice.ConfigureDriver()
//
// Configures the DriverX driver in the system registry.
//
// Returns True if successful, False on error.

class function TDxDevice.ConfigureDriver: Boolean;
var
   KeyDriver, KeyParameters: HKEY;
   Ret: Cardinal;
   Value: Cardinal;
   Buf: string;
   SCManager : SC_HANDLE;
   Service : SC_HANDLE;

begin

   if (IsOn95) then
   begin
      // Create key for VxD
      Ret := OpenKey(HKEY_LOCAL_MACHINE,
         'System\CurrentControlSet\Services\VxD\DRIVERX',
         KeyDriver,
         True);

      if (Ret <> ERROR_SUCCESS) then
      begin
         Result := False;
         Exit;
      end;

      // Add standard driver key values
      Buf := 'DRIVERX.VXD';
      Ret := RegSetValueEx(KeyDriver,
         'StaticVxD',
         0,
         REG_SZ,
         PChar(Buf),
         Length(Buf));

      if (Ret <> ERROR_SUCCESS) then
      begin
         RegCloseKey(KeyDriver);
         Result := False;
         Exit;
      end;

      RegFlushKey(KeyDriver);
      RegCloseKey(KeyDriver);

   end
   else
   begin

      SCManager := OpenSCManager(
         nil,
         nil,
         SC_MANAGER_ALL_ACCESS);

      if (SCManager = 0) then
      begin
	     // User probably does not have admin rights
         Result := False;
         Exit;
      end;

      // Create DriverX service key
      Service := CreateService(
         SCManager,
         'DriverX',
         'DriverX',
         SERVICE_ALL_ACCESS,
         SERVICE_KERNEL_DRIVER,
         SERVICE_AUTO_START,
         SERVICE_ERROR_NORMAL,
         '\SystemRoot\System32\Drivers\driverx.sys',
         nil,
         nil,
         nil,
         nil,
         nil);

      CloseServiceHandle(SCManager);
      if (Service = 0) then
      begin
         if (GetLastError() <> ERROR_SERVICE_EXISTS) then
         begin
            Result := False;
            Exit;
         end
      end
      else
         CloseServiceHandle(Service);

      // Open DriverX service key
      Ret := OpenKey(HKEY_LOCAL_MACHINE,
         'System\CurrentControlSet\Services\DriverX',
         KeyDriver,
         True);

      if (Ret <> ERROR_SUCCESS) then
      begin
         Result := False;
         Exit;
      end;

      // Create Parameters key under driver key
      Ret := OpenKey(KeyDriver, 'Parameters', KeyParameters, True);
      RegCloseKey(KeyDriver);
      if (Ret <> ERROR_SUCCESS) then
      begin
         Result := False;
         Exit;
      end;

      // Add event logging entries
      Ret := OpenKey(HKEY_LOCAL_MACHINE,
         'System\\CurrentControlSet\\Services\\EventLog\\System\\DriverX',
         KeyDriver,
         True);

      if (Ret <> ERROR_SUCCESS) then
      begin
         Result := False;
         Exit;
      end;

      // Add standard driver key values
      Buf := '%SystemRoot%\System32\IoLogMsg.dll;'
   			+ '%SystemRoot%\System32\Drivers\DriverX.sys';

      Ret := RegSetValueEx(KeyDriver,
          'EventMessageFile',
          0,
          REG_EXPAND_SZ,
          PChar(Buf),
          Length(Buf));

      if (Ret <> ERROR_SUCCESS) then
      begin
         RegCloseKey(KeyDriver);
         Result := False;
         Exit;
      end;

      Value := 7;
      Ret := RegSetValueEx(KeyDriver,
          'TypesSupported',
          0,
          REG_DWORD,
          @Value,
          Sizeof(DWORD));

      if (Ret <> ERROR_SUCCESS) then
      begin
         RegCloseKey(KeyDriver);
         Result := False;
         Exit;
      end;

      RegFlushKey(KeyDriver);
      RegCloseKey(KeyDriver);
   end;

   Result := True;
end;

/////////////////// TDxDevice.DeleteDeviceConfiguration()
//
// Deletes a user registry device configuration of a given name.
//
// Return Value:
//
//		True if successful; False if unable to delete the device key.

class function TDxDevice.DeleteDeviceConfiguration(Name: string): Boolean;
var
	Ret: Boolean;
	KeyDevices: HKEY;
	KeyRet: Cardinal;

begin

    // Open driver key
    KeyDevices := 0;
    KeyRet := OpenUserDevicesKey(KeyDevices);
    if (KeyRet <> ERROR_SUCCESS) then
        Ret := False
    else
    begin
        // Delete device configuration key
        KeyRet := RegDeleteKey(KeyDevices, PChar(Name));
        if (KeyRet = ERROR_SUCCESS) then
            Ret := True
        else
            Ret := False;
        RegCloseKey(KeyDevices);
    end;

    Result := Ret;
end;

/////////////////// TDxDevice.EnumerateDevices()

class function TDxDevice.EnumerateDevices(
	Index: Integer; var Name: string; Config: TDxDeviceConfig): Boolean;
var
	KeyUserDevices, KeyDevice: HKEY;
	BufSize: DWORD;
	Time: TFileTime;
	Ret: Cardinal;

begin

   BufSize := 250;
   SetLength(Name, BufSize);

   KeyUserDevices := 0;
   if (OpenUserDevicesKey(KeyUserDevices) <> ERROR_SUCCESS) then
   begin
      Result := False;
      Exit;
   end;

   // Get the device name at index position
   Ret := RegEnumKeyEx(KeyUserDevices, Index,
				PChar(Name), BufSize,
				nil, nil, nil, @time);

   if (Ret <> ERROR_SUCCESS) then
   begin
      RegCloseKey(KeyUserDevices);
      Result := False;
      Exit;
   end;

   // Open the device key
   RegOpenKeyEx(KeyUserDevices,
            PChar(Name), 0, KEY_READ, KeyDevice);

   // Get the device's configuration information
   Config.ReadRegistryConfiguration(KeyDevice);

   RegCloseKey(KeyDevice);
   RegCloseKey(KeyUserDevices);
   Result := True;
end;

/////////////////// TDxDevice.GetDeviceConfig()
//
// Retrieves the registry configuration for a given user-defined device.
//
// Return Value:
//
//		Returns True if device key is found, else returns False.

class function TDxDevice.GetDeviceConfig(Name: string; Config: TDxDeviceConfig): Boolean;
var
   KeyUserDevices: HKEY;
   KeyDevice: HKEY;
   Ret: Integer;

begin
   KeyUserDevices := 0;
   if (OpenUserDevicesKey(KeyUserDevices) <> ERROR_SUCCESS) then
   begin
      Result := False;
      Exit;
   end;

   // Open the device key
   Ret := RegOpenKeyEx(KeyUserDevices,
       PChar(Name), 0, KEY_READ, KeyDevice);

   if (Ret = ERROR_SUCCESS) then
   begin
      Config.ReadRegistryConfiguration(KeyDevice);
      RegCloseKey(KeyDevice);
   end;

   RegCloseKey(KeyUserDevices);
   if (Ret = ERROR_SUCCESS) then
      Result := True
   else
      Result := False;
end;

function TDxDevice.GetBusDataByOffset(Offset: Integer; Buf: Pointer; BufSize: Integer): Boolean;
var
   Params: BusDataParams;
   BytesReturned: DWORD;
begin
   Params.DeviceID   := DeviceId;
   Params.Offset     := Offset;
   Params.BufferSize := BufSize;
   Params.Reserved1  := 0;
   Params.Reserved2  := 0;
   Params.Reserved3  := 0;
   Params.Reserved4  := 0;

   Result := DeviceIoControl(DeviceHandle,
               IOCTL_GET_BUS_DATA_BY_OFFSET,
               @Params,
               Sizeof(BusDataParams),
               Buf,
               BufSize,
               BytesReturned,
               nil);
end;

function TDxDevice.GetBusDataByOffsetEx(Bus, Device, FuncNum: Byte; Offset: Integer; Buf: Pointer; BufSize: Integer): Boolean;
var
   Params: BusDataParams;
   BytesReturned: DWORD;
begin
   Params.DeviceID   := DeviceId;
   Params.Offset     := Offset;
   Params.BufferSize := BufSize;
   Params.Bus        := Bus;
   Params.Device     := Device;
   Params.FuncNum    := FuncNum;
   Params.Reserved1  := 0;
   Params.Reserved2  := 0;
   Params.Reserved3  := 0;
   Params.Reserved4  := 0;

   Result := DeviceIoControl(DeviceHandle,
               IOCTL_GET_BUS_DATA_BY_OFFSET_EX,
               @Params,
               Sizeof(BusDataParams),
               Buf,
               BufSize,
               BytesReturned,
               nil);
end;

function TDxDevice.SetBusDataByOffset(Offset: Integer; Buf: Pointer; BufSize: Integer): Boolean;
var
   Params: PBusDataParams;
   BytesReturned: DWORD;
begin
   Params := PBusDataParams(HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY,
           Sizeof(BusDataParams) + BufSize));

   Params.DeviceID   := DeviceId;
   Params.Offset     := Offset;
   Params.BufferSize := BufSize;
   Move(Buf, Params.Buffer, BufSize);

   Result := DeviceIoControl(DeviceHandle,
               IOCTL_SET_BUS_DATA_BY_OFFSET,
               Params,
               Sizeof(BusDataParams) + BufSize,
               nil,
               0,
               BytesReturned,
               nil);

   HeapFree(GetProcessHeap(), 0, Params);
end;

function TDxDevice.SetBusDataByOffsetEx(Bus, Device, FuncNum: Byte; Offset: Integer; Buf: Pointer; BufSize: Integer): Boolean;
var
   Params: PBusDataParams;
   BytesReturned: DWORD;
begin
   Params := PBusDataParams(HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY,
           Sizeof(BusDataParams) + BufSize));

   Params.DeviceID   := DeviceId;
   Params.Bus        := Bus;
   Params.Device     := Device;
   Params.FuncNum    := FuncNum;
   Params.Offset     := Offset;
   Params.BufferSize := BufSize;
   Move(Buf, Params.Buffer, BufSize);

   Result := DeviceIoControl(DeviceHandle,
               IOCTL_SET_BUS_DATA_BY_OFFSET_EX,
               Params,
               Sizeof(BusDataParams) + BufSize,
               nil,
               0,
               BytesReturned,
               nil);

   HeapFree(GetProcessHeap(), 0, Params);
end;

			/////////////////////////////////////
			// TDxDeviceConfig implementation
			////////////////////////////////////

constructor TDxDeviceConfig.Create;
begin
  inherited Create;
  InitConfiguration;
end;

procedure TDxDeviceConfig.ConfigureInterface(NewType, NewNumber: Integer);
begin
   InterfaceType := NewType;
   BusNumber := NewNumber;
end;

/////////////////// TDxDeviceConfig.ConfigureInterrupt()
//
// Stores an interrupt configuration in a TDxDeviceConfig object.

procedure TDxDeviceConfig.ConfigureInterrupt(Level: Integer);
begin
	InterruptLevel := Level;
	UsesInterrupt := True;
end;

/////////////////// TDxDeviceConfig.ConfigurePortRange()
//
// Stores a port range configuration in a TDxDeviceConfig object.

procedure TDxDeviceConfig.ConfigurePortRange(Base, Count: Integer);
begin
	PortBase := Base;
	PortCount := Count;
	UsesPortRange := True;
end;

/////////////////// TDxDeviceConfig.ConfigureMemRange()
//
// Stores a memory range configuration in a TDxDeviceConfig object.

procedure TDxDeviceConfig.ConfigureMemRange(Base, Count: Integer);
begin
   MemBase := Base;
   MemCount := Count;
   UsesMemRange := True;
end;

/////////////////// TDxDeviceConfig.ConfigureIsrOp()

procedure TDxDeviceConfig.ConfigureIsrOp(Op, Offset, Data: Integer);
begin
  IsrOp := Op;
  IsrOffset := Offset;
  IsrData := Data;
end;

/////////////////// TDxDeviceConfig.ConfigureIsrIdOp()

procedure TDxDeviceConfig.ConfigureIsrIdOp(Op, Offset, Mask, Value: Integer);
begin
  IsrIdOp := Op;
  IsrIdOffset := Offset;
  IsrIdMask := Mask;
  IsrIdValue := Value;
end;

/////////////////// QueryDwordValue()

function QueryDwordValue(Key: HKEY; Name: string; var Value: Integer): Integer;
var
	Size, DataType: Integer;
begin
	Size := Sizeof(Cardinal);
   DataType := REG_DWORD;
	Result := RegQueryValueEx(Key, PChar(Name), nil, @DataType,
		@Value, @Size);
end;

/////////////////// SetDwordValue()

function SetDwordValue(Key: HKEY; Name: string; Value: Integer): Integer;
begin
	Result := RegSetValueEx(Key, PChar(Name), 0, REG_DWORD,
				@Value, Sizeof(DWORD));
end;

/////////////////// TDxDeviceConfig.InitConfiguration()

procedure TDxDeviceConfig.InitConfiguration;
begin
   DynamicDevice   := False;
   IgnoreConflicts := False;
   VendorID        := 0;
   DeviceID        := 0;
   MemoryIo        := False;
   InterfaceType   := 1; // ISA
   BusNumber       := 0;
   UsesPortRange   := False;
   PortBase        := 0;
   PortCount       := 0;
   UsesInterrupt   := False;
   InterruptLevel  := 0;
   IsrOp           := 0;
   IsrData         := 0;
   IsrOffset       := 0;
   IsrIdOp         := 0;
   IsrIdOffset     := 0;
   IsrIdMask       := 0;
   IsrIdValue      := 0;
   UsesMemRange    := False;
   MemBase         := 0;
   MemCount        := 0;
end;

/////////////////// TDxDeviceConfig.ReadRegistryConfiguration()
//
// Reads the registry configuration values for a device.
//
// Parameters:
//
//		KeyDevice (IN) - handle to device key.

procedure TDxDeviceConfig.ReadRegistryConfiguration(Key: HKEY);
var
   Ret: Integer;
   Value: Integer;

begin

   InitConfiguration;

   Ret := QueryDwordValue(Key, 'BusNumber', Value);
   if (Ret = ERROR_SUCCESS) then
     BusNumber := Value;

   // See if interface is defined
   Ret := QueryDwordValue(Key, 'InterfaceType', Value);
   if (Ret = ERROR_SUCCESS) then
   begin
      InterfaceType := Value;
      if (Value = 5) then // PCI bus
	  begin
         Ret := QueryDwordValue(Key, 'VendorID', Value);
         if (Ret = ERROR_SUCCESS) then
         begin
            VendorID := Value;
            Ret := QueryDwordValue(Key, 'DeviceID', Value);
            if (Ret = ERROR_SUCCESS) then
               DeviceID := Value;
         end;
      end;
   end;

   // See if PortBase and PortCount values are defined.
   Ret := QueryDwordValue(Key, 'PortBase', Value);
   if (Ret = ERROR_SUCCESS) then
   begin
      PortBase := Value;

      Ret := QueryDwordValue(Key, 'PortCount', Value);
      if (Ret <> ERROR_SUCCESS) then
         PortBase := 0
      else
      begin
         UsesPortRange := True;
         PortCount := Value;
      end;
   end;

   // See if an interrupt level is defined
   Ret := QueryDwordValue(Key, 'InterruptLevel', Value);
   if (Ret = ERROR_SUCCESS) then
   begin
      UsesInterrupt := True;
      InterruptLevel := Value;
   end;

   // Look for optional ISR op (added in 3.0)
   Ret := QueryDwordValue(Key, 'IsrOp', Value);
   if ((Ret = ERROR_SUCCESS) And (Value <> 0)) then
   begin
      IsrOp := Value;

      Ret := QueryDwordValue(Key, 'IsrOffset', Value);
      if (Ret = ERROR_SUCCESS) then
         IsrOffset := Value;

      Ret := QueryDwordValue(Key, 'IsrData', Value);
      if (Ret = ERROR_SUCCESS) then
         IsrData := Value;
   end;

   // Look for optional ISR ID op (added in 3.3)
   Ret := QueryDwordValue(Key, 'IsrIdOp', Value);
   if ((Ret = ERROR_SUCCESS) And (Value <> 0)) then
   begin
      IsrIdOp := Value;

      Ret := QueryDwordValue(Key, 'IsrIdOffset', Value);
      if (Ret = ERROR_SUCCESS) then
         IsrIdOffset := Value;

      Ret := QueryDwordValue(Key, 'IsrIdMask', Value);
      if (Ret = ERROR_SUCCESS) then
         IsrIdMask := Value;

      Ret := QueryDwordValue(Key, 'IsrIdValue', Value);
      if (Ret = ERROR_SUCCESS) then
         IsrIdValue := Value;
   end;

   // See if device is dynamic (added in 2.8)
   Ret := QueryDwordValue(Key, 'Dynamic', Value);
   if (Ret = ERROR_SUCCESS) then
      DynamicDevice := (Value <> 0);

   // Added mem range in 2.8
   Ret := QueryDwordValue(Key, 'MemBase', Value);
   if (Ret = ERROR_SUCCESS) then
   begin
      MemBase := Value;

      Ret := QueryDwordValue(Key, 'MemCount', Value);
      if (Ret <> ERROR_SUCCESS) then
         UsesMemRange := False
      else
         MemCount := Value;
   end;

   // See if device ignores resource conflicts
   Ret := QueryDwordValue(Key, 'IgnoreConflicts', Value);
   if (Ret = ERROR_SUCCESS) then
      IgnoreConflicts := (Value <> 0);

   // See if device uses memory mapped registers
   Ret := QueryDwordValue(Key, 'MemoryIo', Value);
   if (Ret = ERROR_SUCCESS) then
      MemoryIo := (Value <> 0);

   // See if device uses DMA buffer
   Ret := QueryDwordValue(Key, 'DmaBufSize', Value);
   if (Ret = ERROR_SUCCESS) then
      DmaBufSize := Value;

end;

/////////////////// SetRegistryConfiguration()
//
// Helper routine to store configuration values under a user-defined
// device registry key.

function TDxDeviceConfig.SetRegistryConfiguration(Key: HKEY): Integer;
begin
   // Delete any existing configuration
   RegDeleteValue(Key, 'InterfaceType');
   RegDeleteValue(Key, 'BusNumber');
   RegDeleteValue(Key, 'VendorID');
   RegDeleteValue(Key, 'DeviceID');
   RegDeleteValue(Key, 'PortBase');
   RegDeleteValue(Key, 'PortCount');
   RegDeleteValue(Key, 'InterruptLevel');
   RegDeleteValue(Key, 'IsrOp');
   RegDeleteValue(Key, 'IsrData');
   RegDeleteValue(Key, 'IsrOffset');
   RegDeleteValue(Key, 'Dynamic');
   RegDeleteValue(Key, 'IgnoreConflicts');
   RegDeleteValue(Key, 'MemBase');
   RegDeleteValue(Key, 'MemCount');
   RegDeleteValue(Key, 'IsrIdOp');
   RegDeleteValue(Key, 'IsrIdOffset');
   RegDeleteValue(Key, 'IsrIdMask');
   RegDeleteValue(Key, 'IsrIdValue');
   RegDeleteValue(Key, 'MemoryIo');
   RegDeleteValue(Key, 'DmaBufSize');

   if (BusNumber <> 0) then
   begin
      Result := SetDwordValue(Key, 'BusNumber', BusNumber);
      if (Result <> ERROR_SUCCESS) then
	     exit;
   end;

   // Store interface
   if (InterfaceType <> 1) then
   begin
      Result := SetDwordValue(Key, 'InterfaceType', InterfaceType);
      if (Result <> ERROR_SUCCESS) then
        Exit;

      if (InterfaceType = 5) then // PCI
      begin

         // Set vendor and device ID values for PCI device
         Result := SetDwordValue(Key, 'VendorID', VendorID);
         if (Result <> ERROR_SUCCESS) then
            Exit;

         Result := SetDwordValue(Key, 'DeviceID', DeviceID);
         if (Result <> ERROR_SUCCESS) then
            Exit;

         RegFlushKey(Key);
      end;
   end;

   // Store port range
   if (UsesPortRange) then
   begin
      Result := SetDwordValue(Key, 'PortBase', PortBase);
      if (Result <> ERROR_SUCCESS) then
         Exit;

	  Result := SetDwordValue(Key, 'PortCount', PortCount);
      if (Result <> ERROR_SUCCESS) then
         Exit;
   end;

   // Store interrupt
   if (UsesInterrupt) then
   begin
      Result := SetDwordValue(Key, 'InterruptLevel', InterruptLevel);
      if (Result <> ERROR_SUCCESS) then
         Exit;
   end;

   // Store ISR op -added in 3.0
   if (IsrOp <> 0) then
   begin
      Result := SetDwordValue(Key, 'IsrOp', IsrOp);
      if (Result <> ERROR_SUCCESS) then
         Exit;

      Result := SetDwordValue(Key, 'IsrOffset', IsrOffset);
      if (Result <> ERROR_SUCCESS) then
         Exit;

      Result := SetDwordValue(Key, 'IsrData', IsrData);
      if (Result <> ERROR_SUCCESS) then
         Exit;
	end;

    // Store ISR ID op -added in 3.3
    if (IsrIdOp <> 0) then
    begin
       Result := SetDwordValue(Key, 'IsrIdOp', IsrIdOp);
	   if (Result <> ERROR_SUCCESS) then
          Exit;

       Result := SetDwordValue(Key, 'IsrIdOffset', IsrIdOffset);
	   if (Result <> ERROR_SUCCESS) then
          Exit;

       Result := SetDwordValue(Key, 'IsrIdMask', IsrIdMask);
	   if (Result <> ERROR_SUCCESS) then
          Exit;

       Result := SetDwordValue(Key, 'IsrIdValue', IsrIdValue);
	   if (Result <> ERROR_SUCCESS) then
          Exit;
	end;

   // Store dynamic flag -added in 2.8
   if (DynamicDevice) then
   begin
      Result := SetDwordValue(Key, 'Dynamic', 1);
      if (Result <> ERROR_SUCCESS) then
         Exit;
   end;

   // Store memory range -added in 2.8
   if (UsesMemRange) then
   begin
      Result := SetDwordValue(Key, 'MemBase', MemBase);
      if (Result <> ERROR_SUCCESS) then
         Exit;

      Result := SetDwordValue(Key, 'MemCount', MemCount);
      if (Result <> ERROR_SUCCESS) then
         Exit;
   end;

   // Store ignore conflicts flag
   if (IgnoreConflicts) then
   begin
      Result := SetDwordValue(Key, 'IgnoreConflicts', 1);
      if (Result <> ERROR_SUCCESS) then
         Exit;
   end;

   if (MemoryIo) then
   begin
      Result := SetDwordValue(Key, 'MemoryIo', 1);
      if (Result <> ERROR_SUCCESS) then
         Exit;
   end;

   if (DmaBufSize <> 0) then
   begin
      Result := SetDwordValue(Key, 'DmaBufSize', DmaBufSize);
      if (Result <> ERROR_SUCCESS) then
         Exit;
   end;

   RegFlushKey(Key);
   Result := ERROR_SUCCESS;
end;

			/////////////////////////////////////
			// TIsrThread implementation
			////////////////////////////////////

/////////////////// Create()

constructor TIsrThread.Create(Device: TDxDevice);
begin
   inherited Create(True);       // Create in SUSPENDED_MODE = TRUE
   Priority := tpHighest;
   ParentDevice := Device;
end;

/////////////////// Execute()
//
// This routine blocks on interrupts in the driver and calls the parent
// device OnInterrupt routine.

procedure TIsrThread.Execute;
var
   Return: Boolean;
   Done: Boolean;
   WaitReturn: Cardinal;
   BytesReturned: DWORD;
   Overlapped: TOverlapped;
   EventHandles : array [0..1] of THandle;

begin

   // Setup overlapped structure for DeviceIoControl call
   Overlapped.hEvent := CreateEvent(nil, True, False, nil);

   // Block on either (a) an interrupt, or (b) the ISR being disabled
   EventHandles[0] := Overlapped.hEvent;
   EventHandles[1] := ParentDevice.GetCancelEvent;

   // Set the Isr enabled flag on the driver
   ParentDevice.SetProperty(DXPROP_ISR_ENABLED, 1);

   Done := False;
   while not Terminated and not Done do
   begin

       // Send 'wait interrupt' request to driver
       ResetEvent(Overlapped.hEvent);
       Return := DeviceIoControl(ParentDevice.GetDeviceHandleIsr,
           IOCTL_WAIT_INTERRUPT,
           @ParentDevice.DeviceID, sizeof(Cardinal),
           @ParentDevice.WaitOutput, sizeof(TWaitInterruptOutput),
           BytesReturned,
           @Overlapped);

       if Return = True then
       begin
           // Call completed. Check cancel event before continuing
           if (WaitForSingleObject(ParentDevice.GetCancelEvent, 0) = WAIT_OBJECT_0) then
               Done := True;
       end
       else
       begin
           // Check for proper overlapped return
           if GetLastError() <> ERROR_IO_PENDING then
               Done := TRUE
           else
           begin
               WaitReturn := WaitForMultipleObjects(
                   2, @EventHandles, False, INFINITE);
               if (WaitReturn = 1) then
                   // Parent device is shutting down the interrupt
                   Done := True
               else if (WaitReturn = 0) then
                   GetOverlappedResult(ParentDevice.GetDeviceHandleIsr,
                       Overlapped, BytesReturned, False)
               else
                   // Some strange error communication error
                   Done := True;
           end;
       end;

       // If not done, call OnInterrupt member of parent device
       if not Done then
       begin
           EnterCriticalSection(ParentDevice.CriticalSection);

           try
               ParentDevice.OnInterrupt
           except
               on Exception do
               begin
                   // Cleanup and pass exception to outer handler
                   LeaveCriticalSection(ParentDevice.CriticalSection);
                   CloseHandle(Overlapped.hEvent);
                   ParentDevice.SetProperty(DXPROP_ISR_ENABLED, 0);
                   raise;
               end;
           end;

           LeaveCriticalSection(ParentDevice.CriticalSection);
       end;
   end;

   // Cleanup overlapped structure
   CloseHandle(Overlapped.hEvent);

   // Set flag in driver than ISR thread is no longer running
   ParentDevice.SetProperty(DXPROP_ISR_ENABLED, 0);

end;

			/////////////////////////////////////
			// TDxMemory implementation
			////////////////////////////////////

/////////////////// TDxMemory.Destroy

destructor TDxMemory.Destroy;
begin
   UnmapMemory;
end;

/////////////////// TDxMemory.MapDeviceMemory()
//
// MapDeviceMemory maps a pre-defined device memory range defined
// by a device's registry configuration/INF file/or PCI configuration.
// If the registry or INF file MemIndex value is defined, then the
// memory range specified by the MemIndex parameter is mapped.

function TDxMemory.MapDeviceMemory(Device: TDxDevice): Boolean;
begin
   UnmapMemory;
   AssocDevice := Device;

   // If type has not already been set by calling SetIndex...
   if (MemType <> DXMEM_TYPE_DEVICE2) then
      MemType := DXMEM_TYPE_DEVICE;

   Result := MapMemoryEx(0, 0, 0, 0);
end;

function TDxMemory.MapDmaBuffer(Device: TDxDevice): Boolean;
begin
   UnmapMemory;
   AssocDevice := Device;
   MemType := DXMEM_TYPE_DMA_BUFFER;
   Result := MapMemoryEx(0, 0, 0, 0);
end;

/////////////////// TDxMemory.MapMemory()
//
// Maps a range of physical addresses into the callers processes virtual
// address space.
//
// Parameters:
//
//		BaseAddress (IN) - base physical address
//		Count (IN) - length of physical address range to map.
//
// Return Value:
//
//		Returns TRUE if successful, FALSE on error.

function TDxMemory.MapMemory(BaseAddress, Count: Integer): Boolean;
begin
   UnmapMemory;
   AssocDevice := nil;
   MemType := DXMEM_TYPE_PHYSICAL;
   Result := MapMemoryEx(BaseAddress, Count, 0, 1 {Isa});
end;

/////////////////// TDxMemory.MapMemoryEx()
//
// Helper routine.

function TDxMemory.MapMemoryEx(BaseAddress, Count, InterfaceType,
   BusNumber: Integer): Boolean;
var
   Input: MapmemInput;
   BytesReturned: DWORD;
   Ret: Boolean;
   Device: TDxDevice;

begin

   UnmapMemory;

   // If no associated device, use _Default30 device
   if (AssocDevice <> nil) then
      Device := AssocDevice
   else
   begin
      Device := TDxDevice.Create;
      if Device.ConnectDevice('') <> True then
      begin
         Device.Free;
         Result := False;
         Exit;
      end;
   end;

   Input.DeviceID      := Device.GetID;
   Input.MemType       := MemType;
   Input.InterfaceType := InterfaceType;
   Input.BusNumber     := BusNumber;
   Input.Address       := BaseAddress;
   Input.Length        := Count;
   Input.AddressSpace  := 0;	// memory space
   Input.Index         := Index;

   Output.PhysicalAddress := 0;
   Output.HalAddress      := 0;
   Output.VirtualAddress  := 0;
   Output.DriverVirtualAddress := 0;
   Output.Count           := 0;
   Output.PhysicalAddress := 0;
   Output.Reserved2       := 0;
   Output.Reserved3       := 0;

   Ret := DeviceIoControl(Device.GetDeviceHandle,
               IOCTL_MAP_MEMORY,
               @Input,
               Sizeof(MapmemInput),
               @Output,
               Sizeof(MapmemOutput),
               BytesReturned,
               nil);

   if (BytesReturned <> Sizeof(MapmemOutput)) then
      Ret := False;

   if (Output.VirtualAddress = 0) then
      Ret := False;

   // Close handle to _Default30 device (if used)
   if (AssocDevice <> Device) then
      Device.Free;

   Result := Ret;
end;

/////////////////// TDxMemory.GetMemoryPointer()

function TDxMemory.GetMemoryPointer: Pointer;
begin
   Result := Pointer(Output.VirtualAddress);
end;

function TDxMemory.GetPhysicalAddress: Integer;
begin
   Result := Output.PhysicalAddress;
end;

function TDxMemory.GetSize: Integer;
begin
   Result := Output.Count;
end;

function TDxMemory.GetMemoryIndex;
begin
  Result := Index;
end;

procedure TDxMemory.SetMemoryIndex(i: Integer);
begin
  if (Output.VirtualAddress = 0) then
  begin
     // Set type to DXMEM_TYPE_DEVICE2 so driver uses Index parameter
     MemType := DXMEM_TYPE_DEVICE2;
     Index := i;
  end;
end;

/////////////////// TDxMemory.UnmapMemory()

function TDxMemory.UnmapMemory: Boolean;
var
   BytesReturned: DWORD;
   Ret: Boolean;
   Input: UnmapmemInput;
   Device: TDxDevice;

begin
   if (Output.VirtualAddress = 0) then
   begin
      Result := True; // Not mapped
      Exit;
   end;

   // If no associated device, use _Default30 device
   if (AssocDevice <> nil) then
       Device := AssocDevice
   else
   begin
       Device := TDxDevice.Create;
       if Device.ConnectDevice('') <> True then
       begin
          Device.Free;
          Result := False;
          Exit;
       end;
   end;

   Input.DeviceID  := Device.GetID;
   Input.MemType   := MemType;
   Input.DriverVirtualAddress := Output.DriverVirtualAddress;
   Input.Index     := Index;
   Input.Reserved2 := 0;
   Input.Reserved3 := 0;
   Input.Reserved4 := 0;
   Input.Reserved5 := 0;

   Ret := DeviceIoControl(Device.GetDeviceHandle,
                   IOCTL_UNMAP_MEMORY,
                   @Input,
                   Sizeof(UnmapmemInput),
                   nil,
                   0,
                   BytesReturned,
                   nil);

   if (Device <> AssocDevice) then
       Device.Free;

   Output.PhysicalAddress := 0;
   Output.HalAddress      := 0;
   Output.VirtualAddress  := 0;
   Output.DriverVirtualAddress := 0;
   Output.Count           := 0;
   Output.PhysicalAddress := 0;
   Output.Reserved2       := 0;
   Output.Reserved3       := 0;

   Result := Ret;
end;

end.

